/*
This file is part of DeNa Drive.

DeNa Drive is free software: you can redistribute it and/or modify it under the terms of the
GNU General Public License as published by the Free Software Foundation,
either version 3 of the License, or (at your option) any later version.

DeNa Drive is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with DeNa Drive.
If not, see <https://www.gnu.org/licenses/>.
*/

package com.bbc.denadrive

//import com.bbc.denadrive.apihandlers.MyFile
//import kotlinx.coroutines.DelicateCoroutinesApi
//import kotlinx.coroutines.GlobalScope
//import kotlinx.coroutines.async
//import kotlinx.coroutines.awaitAll
//import kotlinx.coroutines.coroutineScope
//import kotlinx.coroutines.launch
//
//class FolderTreeBuilder(
//    private val childGetterFunction: (MyFile) -> Pair<FolderTree, List<MyFile>>,
//    private val rootFolder: MyFile = MyFile(
//        kind = "drive#file",
//        mimeType = "application/vnd.google-apps.folder",
//        id = "root",
//        name = "My Drive"
//    )
//) {
//
//    fun build(): FolderTree {
//        return unfoldToFolderTree(
//            childGetterFunction,
//            rootFolder
//        )
//    }
//
//    fun faiStoAlbero(
//        seed: MyFile,
//        getChildren: (MyFile) -> List<MyFile>
//    ): FolderTree {
//        val albero = FolderTree(seed)
//        val childrenSeeds = getChildren(seed)
//        for (x in childrenSeeds) {
//            albero.accChild(faiStoAlbero(x, getChildren))
//        }
//        return albero
//    }
//
//    @OptIn(DelicateCoroutinesApi::class)
//    private fun generateTree(
//        seed: MyFile,
//        fetchChildren: suspend (MyFile) -> MutableList<MyFile>,
//        callback: (FolderTree) -> Unit
//    ) {
//        GlobalScope.launch {
//            val result = generateTreeAsync(seed, fetchChildren)
//            callback(result)
//        }
//    }
//
//    private suspend fun generateTreeAsync(
//        seed: MyFile,
//        fetchChildren: suspend (MyFile) -> MutableList<MyFile>
//    ): FolderTree = coroutineScope {
//
//        val childrenSeeds = fetchChildren(seed)
//        val children = childrenSeeds.map { child -> async { generateTreeAsync(child, fetchChildren) } }
//            .awaitAll()
//
//        val mutableChildren = mutableListOf<FolderTree>()
//        mutableChildren.addAll(children)
//
//        FolderTree(seed, mutableChildren)
//    }
//
//    private fun unfoldToFolderTree(
//        getTreeFromFile: (MyFile) -> Pair<FolderTree, List<MyFile>>,
//        seed: MyFile
//    ): FolderTree {
//        val pair = getTreeFromFile(seed)
//        if (pair.first.isLeaf()) return pair.first
//        pair.first.addChildren(
//            pair.second.map { file ->
//                unfoldToFolderTree(
//                    getTreeFromFile, file
//                )
//            }
//        )
//        return pair.first
//    }
//
//}