package com.bbc.denadrive.apihandlers

import kotlinx.serialization.SerializationException
import kotlinx.serialization.json.Json

object ResponsesHandler {

    inline fun <reified T> newResponseArrived(response: String?): T? {
        if (response == null) return null
        return try {
            Json.decodeFromString<T>(response)
        } catch (e: SerializationException) {
            null
        }
    }

}